local e=require"luci.http"
local s=require"nixio"
local o=require"luci.ltn12"
local d=require"table"
local i=require"luci.util"
module("luci.controller.istore_backend",package.seeall)
local t=2048
local n=3038
function index()
entry({"istore"},call("istore_backend")).leaf=true
end
local function h(e,a)
if e then
return function(t,a)
if not t then
return 1
else
return e:send(t)
end
end
else
return o.sink.error(a or"unable to send socket")
end
end
local function r(a,t)
local e=i.ubus("session","get",{ubus_rpc_session=a})
if type(e)=="table"and
type(e.values)=="table"and
type(e.values.token)=="string"and
(not t or
i.contains(t,e.values.username))
then
return a,e.values
end
return nil,nil
end
local function l()
local t
local a
local a
for i,o in ipairs({"sysauth_https","sysauth_http","sysauth"})do
t=e.getcookie(o)
if t then
t,a=r(t,nil)
if t and a then
return t,a
end
end
end
return nil,nil
end
local function r(i,t)
t=t or""
return function()
local o
local n,a,e=t:find("^([0-9a-fA-F]+);?.-\r\n")
while not e and#t<=1024 do
local o,i=i:recv(1024-#t)
if not o then
return nil,i
end
t=t..o
n,a,e=t:find("^([0-9a-fA-F]+);?.-\r\n")
end
e=tonumber(e,16)
if not e then
return nil,-1,"invalid encoding"
elseif e==0 then
return nil
elseif e+2<=#t-a then
o=t:sub(a+1,a+e)
t=t:sub(a+e+3)
return o
else
o=t:sub(a+1,a+e)
t=""
if e-#o>0 then
local t,a=i:recvall(e-#o)
if not t then
return nil,a
end
o=o..t
e,a=i:recvall(2)
else
e,code=i:recvall(e+2-#t+a)
end
if not e then
return nil,code
end
return o
end
end
end
function istore_backend()
local a=s.connect("127.0.0.1",n)
if not a then
e.status(500,"connect failed")
return
end
local t={}
t[#t+1]=e.getenv("REQUEST_METHOD").." "..e.getenv("REQUEST_URI").." HTTP/1.1"
local u=e.context.request
local s="HTTP_"
local i=string.len(s)
local n=e.getenv("CONTENT_TYPE")
if n then
t[#t+1]="Content-Type: "..n
end
for e,a in pairs(u.message.env)do
if string.sub(e,1,i)==s and not string.find(e,"FORWARDED")then
t[#t+1]=string.sub(e,i+1,string.len(e))..": "..a
end
end
local n,i=l()
if i~=nil then
t[#t+1]="X-Forwarded-Sid: "..n
t[#t+1]="X-Forwarded-Token: "..i.token
end
local n=tonumber(e.getenv("CONTENT_LENGTH"))or 0
t[#t+1]="Content-Length: "..tostring(n)
t[#t+1]="\r\n"
local t=o.source.cat(o.source.string(d.concat(t,"\r\n")),e.source())
local t=o.pump.all(t,h(a,"write sock error"))
if t~=1 then
a:close()
e.status(500,"proxy error")
return
end
local i=a:linesource()
local t,s,s=i()
if not t then
a:close()
e.status(500,"response parse failed")
return
end
local s,d,h=t:match("^([%w./]+) ([0-9]+) (.*)")
if not s then
a:close()
e.status(500,"response protocol error")
return
end
n=tonumber(d)or 0
e.status(n,h)
local n=0
t=i()
while t and t~=""do
local a,o=t:match("^([%w-]+)%s?:%s?(.*)")
if a and a~="Status"then
if a=="Transfer-Encoding"and o=="chunked"then
n=1
end
if a~="Connection"and a~="Transfer-Encoding"and a~="Content-Length"then
e.header(a,o)
end
end
t=i()
end
if not t then
a:close()
e.status(500,"parse header failed")
return
end
local t=i(true)
if n==1 then
o.pump.all(r(a,t),e.write)
else
local t=o.source.cat(o.source.string(t),a:blocksource())
o.pump.all(t,e.write)
end
a:close()
end
