local e=require"luci.http"
module("luci.controller.quickstart",package.seeall)
function index()
if luci.sys.call("pgrep quickstart >/dev/null")==0 then
entry({"admin","quickstart"},template("quickstart/home"),_("QuickStart"),1).leaf=true
entry({"admin","network_guide"},call("networkguide_index"),_("NetworkGuide"),2)
entry({"admin","network_guide","pages"},call("quickstart_index",{index={"admin","network_guide","pages"}})).leaf=true
if nixio.fs.access("/usr/lib/lua/luci/view/quickstart/main_dev.htm")then
entry({"admin","quickstart_dev"},call("quickstart_dev",{index={"admin","quickstart_dev"}})).leaf=true
end
entry({"admin","nas","raid"},call("quickstart_index",{index={"admin","nas"}}),_("RAID"),10).leaf=true
entry({"admin","nas","smart"},call("quickstart_index",{index={"admin","nas"}}),_("S.M.A.R.T."),11).leaf=true
entry({"admin","network","interfaceconfig"},call("quickstart_index",{index={"admin","network"}}),_("NetworkPort"),11).leaf=true
entry({"admin","nas","quickstart"}).dependent=false
entry({"admin","nas","quickstart","auto_setup"},post("auto_setup"))
entry({"admin","nas","quickstart","setup_result"},call("setup_result"))
else
entry({"admin","quickstart"},call("redirect_fallback")).leaf=true
end
end
function networkguide_index()
luci.http.redirect(luci.dispatcher.build_url("admin","network_guide","pages","network"))
end
function redirect_fallback()
luci.http.redirect(luci.dispatcher.build_url("admin","status"))
end
local function t()
local e=require("luci.i18n")
local e=e.translate("quickstart_vue_lang")
if e=="quickstart_vue_lang"or e==""then
e="en"
end
return e
end
function quickstart_index(e)
luci.template.render("quickstart/main",{prefix=luci.dispatcher.build_url(unpack(e.index)),lang=t()})
end
function quickstart_dev(e)
luci.template.render("quickstart/main_dev",{prefix=luci.dispatcher.build_url(unpack(e.index)),lang=t()})
end
function auto_setup()
local i=require"os"
local a=require"nixio.fs"
local n=nixio.bit.rshift
local e=luci.http.formvalue("packages")
local t=""
if type(e)=="table"then
if#e>0 then
for a,e in pairs(e)do
t=t.." "..luci.util.shellquote(e)
end
end
else
if e~=nil and e~=""then
t=luci.util.shellquote(e)
end
end
local o
if t==""then
o={
success=1,
scope="params",
error="Parameter 'packages' undefined!",
}
else
local e="/usr/libexec/quickstart/auto_setup.sh "..t
e="/etc/init.d/tasks task_add auto_setup "..luci.util.shellquote(e)
local t=i.execute(e.." >/var/log/auto_setup.stdout 2>/var/log/auto_setup.stderr")
local e=a.readfile("/var/log/auto_setup.stderr")
local i=a.readfile("/var/log/auto_setup.stdout")
a.unlink("/var/log/auto_setup.stderr")
a.unlink("/var/log/auto_setup.stdout")
e=e or""
if t==256 and e==""then
e="os.execute exit code 1"
end
t=n(t,8)
o={
success=t,
scope="taskd",
error=e,
detail=i,
}
end
luci.http.prepare_content("application/json")
luci.http.write_json(o)
end
function setup_result()
local i=require"nixio.fs"
local e=require"luci.model.tasks"
local a=nil
local t=nil
local o=nil
local n=e.status("auto_setup")
local e={
}
if n.running or n.exit_code~=404 then
local s
local s=i.readfile("/var/log/auto_setup.input")or""
for e in s:gmatch("[^\n]+")do
if a then
a[#a+1]=e
else
a={e}
end
end
local s=i.readfile("/var/log/auto_setup.success")or""
for e in s:gmatch("[^\n]+")do
if t then
t[#t+1]=e
else
t={e}
end
end
local i=i.readfile("/var/log/auto_setup.failed")or""
for t in i:gmatch("[^\n]+")do
if o then
o[#o+1]=t
else
o={t}
end
end
e.success=0
e.result={
ongoing=n.running,
packages=a,
success=t,
failed=o,
}
else
e.success=404
e.scope="taskd"
e.error="task not found"
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
